//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                  i-PSI@PolyMA.mq4 |
//|                  Copyright  2007-13, Igor Stepovoi aka TarasBY & TrendLaboratory |
//|                                                                taras_bulba@tut.by |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Yellow
#property indicator_width1  2  
#property indicator_color2  DodgerBlue
#property indicator_width2  2  
#property indicator_color3  OrangeRed
#property indicator_width3  2  
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define       BULL          0
#define       BEAR          1
#define       STOP         -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
// List of MAs:
// MA_Method= 0: SMA        - Simple Moving Average
// MA_Method= 1: EMA        - Exponential Moving Average
// MA_Method= 2: Wilder     - Wilder Exponential Moving Average
// MA_Method= 3: LWMA       - Linear Weighted Moving Average 
// MA_Method= 4: SineWMA    - Sine Weighted Moving Average
// MA_Method= 5: TriMA      - Triangular Moving Average
// MA_Method= 6: LSMA       - Least Square Moving Average (or EPMA, Linear Regression Line)
// MA_Method= 7: SMMA       - Smoothed Moving Average
// MA_Method= 8: HMA        - Hull Moving Average by Alan Hull
// MA_Method= 9: ZeroLagEMA - Zero-Lag Exponential Moving Average
// MA_Method=10: DEMA       - Double Exponential Moving Average by Patrick Mulloy
// MA_Method=11: T3         - T3 by T.Tillson
// MA_Method=12: ITrend     - Instantaneous Trendline by J.Ehlers
// MA_Method=13: Median     - Moving Median
// MA_Method=14: GeoMean    - Geometric Mean
// MA_Method=15: REMA       - Regularized EMA by Chris Satchwell
// MA_Method=16: ILRS       - Integral of Linear Regression Slope 
// MA_Method=17: IE/2       - Combination of LSMA and ILRS 
// MA_Method=18: TriMAgen   - Triangular Moving Average generalized by J.Ehlers
// MA_Method=19: VWMA       - Volume Weighted Moving Average 
// MA_Method=20: JSmooth    - Smoothing by Mark Jurik
// MA_Method=21: T3M        - T3 modification
// List of Prices:
// Price    = 0 - Close  
// Price    = 1 - Open  
// Price    = 2 - High  
// Price    = 3 - Low  
// Price    = 4 - Median Price   = (High+Low)/2  
// Price    = 5 - Typical Price  = (High+Low+Close)/3  
// Price    = 6 - Weighted Close = (High+Low+Close*2)/4
// Price    = 7 - Heiken Ashi Close  
// Price    = 8 - Heiken Ashi Open
// Price    = 9 - Heiken Ashi High
// Price    = 10 - Heiken Ashi Low
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern int    TimeFrame    =  0;
extern int    MA_Period    = 14;
extern int    MA_Shift     =  0;
extern int    MA_Method    =  0;     // 0 - 21;
extern int    MA_Price     =  0;     // 0 - 10;
extern bool   Color_Mode   =  TRUE;
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
#include      <bi-PSI@MA_All.mqh>                  //   MA ( ).
//#include      <b-PSI@Semaphore.mqh>                //     
#include      <bi-PSI@TMPL_IND.mqh>                //        .
#include      <b-PSI@BaseZF.mqh>                   //   
//IIIIIIIIIIIIIIIIIII======  =====IIIIIIIIIIIIIIIIIIIIII+
double         Buf_MA[], Buf_UP[], Buf_DW[], gda_Price[];
int            draw_begin, gi_Bars, gi_preBars = 0, gi_LimitA = 0;   
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom indicator initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
    string short_name,
           lsa_MethodName[] = {"SMA","EMA","Wilder","LWMA","SineWMA","TriMA","LSMA","SMMA","HMA",
                               "ZeroLagEMA","DEMA","T3","InstTrend","Median","GeometricMean","REMA",
                               "ILRS","IE/2","TriMA_gen","VWMA","JSmooth","T3M"},
           lsa_NamePrice[] = {"Close","Open","High","Low","Median","Typical","Weighted",
                               "HA Close","HA Open","HA High","HA Low"};
//---- 
	 //---- "  "  
	 //SemaphoreTake ("INIT");
    draw_begin = MA_Period * TimeFrame / Period();
    //----     
    fInit_MA (MA_Price, MA_Method, TimeFrame, MA_Period);
    if (MA_Price > 6) ArrayResize (bda_PriceHA, Bars);
    short_name = StringConcatenate (lsa_MethodName[MA_Method], "/", lsa_NamePrice[MA_Price], "(", MA_Period, "|", fGet_NameTF (TimeFrame), ")");
    SetIndexStyle (0, DRAW_LINE);
    SetIndexBuffer (0, Buf_MA);
    SetIndexDrawBegin (0, draw_begin);
    SetIndexLabel (0, short_name);
    int li_Shift = MA_Shift * TimeFrame / Period();
    SetIndexShift (0, li_Shift);
    int li_Buf = 1;
    //---- 
    if (Color_Mode)
    {
        SetIndexStyle (1, DRAW_LINE);
        SetIndexBuffer (1, Buf_UP);
        SetIndexDrawBegin (1, draw_begin);
        SetIndexShift (1, li_Shift);
        SetIndexLabel (1, StringConcatenate ("UP[", short_name, "]"));
        SetIndexStyle (2, DRAW_LINE);
        SetIndexBuffer (2, Buf_DW);
        SetIndexShift (2, li_Shift);
        SetIndexDrawBegin (2, draw_begin);
        SetIndexLabel (2, StringConcatenate ("DW[", short_name, "]"));
        li_Buf = 3;
    }
    IndicatorBuffers (li_Buf);
    IndicatorDigits (Digits + 1);
    IndicatorShortName (short_name);
	 //----    
	 //SemaphoreReturn ("INIT");
//----   
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor indicator deinitialization function                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    //if (Semaphore_ON) {SemaphoreClose();}
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom indicator iteration function                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    int li_Limit = fGet_CalculateBars (0, Bars_Recalculate);
//----
    if (li_Limit < 0) return (-1);
    //----  Limit  Bars_Recalculate, ,   
    if (li_Limit > Bars_Recalculate)
    {
        for (int i = 1; i <= draw_begin; i++)
        { 
            Buf_MA[Bars-i] = iMA (NULL, TimeFrame, 1, 0, MA_Method, MA_Price, Bars - i);
            Buf_UP[Bars-i] = 0.;
            Buf_DW[Bars-i] = 0.;
        }
        gi_LimitA = 0;
    }
    //----
    gi_Bars = fGet_BarsOnSymbol (Symbol(), TimeFrame);
    if (gi_preBars != gi_Bars)
    {
        gi_preBars = gi_Bars;
        ArrayResize (gda_Price, gi_Bars);
    }
    if (gi_LimitA > 0) gi_LimitA -= Bars_Recalculate;
    //----   
    for (int y = gi_LimitA; y < gi_Bars; y++)
    {gda_Price[y] = fGet_Price (MA_Price, bda_PriceHA, Symbol(), TimeFrame, gi_Bars - 1 - y);}
    gi_LimitA = gi_Bars - 1;
    //----     
    fCalculate_MA (Symbol(), TimeFrame, MA_Period, MA_Price, MA_Method, gda_Price, Buf_MA, Buf_UP, Buf_DW, bda_tmpMA, bda_TMP, bda_PriceHA, bda_tmpTrend, gi_Bars, li_Limit);
//---- 
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

